angular.module('lmsApp', [
  'ionic',
  'lms.controllers',
  'pascalprecht.translate',
  'door3.css',
  'gpsService',
  'intervalDataService'
])

.run(function($ionicPlatform, $translate, template, appData, intervalCallback, intervalDataService) {
  $ionicPlatform.ready(function() {
	
	if(ionic.Platform.platform() != "win32"){
		appData.uuid 			= device.uuid;
		appData.platform 		= device.platform;
		appData.platformVersion = device.version;
		appData.deviceName 		= device.name;
		appData.deviceModel		= device.model;
		appData.cordova 		= device.cordova;
		appData.appVersion 		= '2.0.2';
		appData.coldStartUp 	= true;
		appData.forcedProvider  = "";
		appData.style 			= "templates/lms/";
	}
	else {
		appData.uuid 			= '******';
		appData.platform 		= 'Windows';
		appData.platformVersion = '10';
		appData.deviceName 		= 'Test Pc';
		appData.deviceModel		= '';
		appData.cordova 		= '?';
		appData.appVersion 		= '2.0.2';
		appData.coldStartUp 	= true;
		appData.forcedProvider  = "";
		appData.style 			= "templates/lms/";
	}
	
	if (window.localStorage['provider'] != appData.appVersion) {
		localStorage.clear(); // remove all of localStorage's properties
		window.localStorage['provider'] = appData.appVersion;
	}
	
	if (appData.forcedProvider != "") {
		window.localStorage['provider'] = appData.forcedProvider;
	}
	
	if (window.localStorage['provider'] == null || window.localStorage['provider'] == undefined || window.localStorage['provider'] == "") {
		window.localStorage['provider'] = "lms";
	}
	template.setTemplate(); // Set right template

    if(window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true); // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    }
	
	/* inititialize properties */
	if (window.localStorage['searchavailable'] == null || window.localStorage['searchavailable'] == undefined || window.localStorage['searchavailable'] == "") {
		window.localStorage['searchavailable'] = false;
	}
	if (window.localStorage['searchpaywithapp'] == null || window.localStorage['searchpaywithapp'] == undefined || window.localStorage['searchpaywithapp'] == "") {
		window.localStorage['searchpaywithapp'] = false;
	}
	if (window.localStorage['searchchargeEnergy'] == null || window.localStorage['searchchargeEnergy'] == undefined || window.localStorage['searchchargeEnergy'] == "") {
		window.localStorage['searchchargeEnergy'] = 0;
	}
	if (window.localStorage['searchconnectorArray'] == null || window.localStorage['searchconnectorArray'] == undefined || window.localStorage['searchconnectorArray'] == "") {
		tempArray = ["IEC-60309-2-single-16", "Chademo", "DOMESTIC-F", "IEC-62196-T2", "IEC-62196-T1", "IEC-62196-T1-COMBO", "IEC-62196-T2-COMBO", "IEC-62196-T3A", "IEC-62196-T3C", "DOMESTIC-A", "DOMESTIC-B", "DOMESTIC-C", "DOMESTIC-D", "DOMESTIC-E", "DOMESTIC-G", "DOMESTIC-H", "DOMESTIC-I", "DOMESTIC-J", "DOMESTIC-K", "DOMESTIC-L", "TESLA-R", "TESLA-S", "IEC-60309-2-three-16", "IEC-60309-2-three-32", "IEC-60309-2-three-64"];
		window.localStorage['searchconnectorArray'] = JSON.stringify(tempArray);
	}
	if (window.localStorage['vat'] == null  || window.localStorage['vat'] == undefined || window.localStorage['vat'] == "") {
		window.localStorage['vat'] = true;
	}
	if (window.localStorage['results'] == null  || window.localStorage['results'] == undefined || window.localStorage['results'] == "") {
		window.localStorage['results'] = 10;
	}
	if (window.localStorage['searchrange'] == null  || window.localStorage['searchrange'] == undefined || window.localStorage['searchrange'] == "") {
		window.localStorage['searchrange'] = 25;
	}
	if (window.localStorage['lmssuperadmin'] == null  || window.localStorage['lmssuperadmin'] == undefined || window.localStorage['lmssuperadmin'] == "") {
		window.localStorage['lmssuperadmin'] = false;
	}
	if (window.localStorage['testservervalue'] == null  || window.localStorage['testservervalue'] == undefined || window.localStorage['testservervalue'] == "") {
		window.localStorage['testservervalue'] = 'https://www.evc-net.com/Services/JSON/AppService.thr';
	}
	
	if (window.localStorage['language'] == null || window.localStorage['language'] == undefined || window.localStorage['language'] == "") {
		window.localStorage['language'] = "en"; // set default
	}
	if (window.localStorage['setLanguage'] == null || window.localStorage['setLanguage'] == undefined || window.localStorage['setLanguage'] == "auto" || window.localStorage['setLanguage'] == "") { // language is not set (or set as auto), so use device language
		window.localStorage['setLanguage'] == "auto";
		$translate.use(window.localStorage['language']); // set language
		if(ionic.Platform.platform() != "win32"){
			navigator.globalization.getPreferredLanguage(
				function (language) {
					if ((str.indexOf('nl') !== -1) || (str.indexOf('NL'))) {
						window.localStorage['language'] = "nl";
					}
					else if ((str.indexOf('de') !== -1) || (str.indexOf('DE'))) {
						window.localStorage['language'] = "de"; // german at the moment not available
					}
					else if ((str.indexOf('fr') !== -1) || (str.indexOf('FR'))) {
						window.localStorage['language'] = "fr"; // german at the moment not available
					}
					else {
						window.localStorage['language'] = "en";
					}
					$translate.use(window.localStorage['language']); // update language
				},
				function () {
					window.localStorage['language'] = "en"; 
					$translate.use(window.localStorage['language']); // update language
				}
			);
		}
		else {
			window.localStorage['language'] = "en";
			$translate.use(window.localStorage['language']); // update language
		}
	}
	else {	
		$translate.use(window.localStorage['setLanguage']); // update language
	}
	intervalDataService.init("homeInterval", intervalCallback.home);
	intervalDataService.init("transactionInterval", intervalCallback.transaction);
  });
  
  //Intialize the pause callback
  $ionicPlatform.on("pause", function() {
		intervalDataservice.pause();
		appData.coldStartUp == true;
  });
  
  //Intialize the resume callback
  $ionicPlatform.on("resume", function() {
		appData.coldStartUp == true;
		intervalDataService.resume();
  });
  
})

.config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider, $translateProvider) {
	for(lang in translations){
		$translateProvider.translations(lang, translations[lang]);
	}
	$translateProvider.preferredLanguage('en');

	$ionicConfigProvider.views.transition("none");
	$ionicConfigProvider.backButton.text("   ");
	$ionicConfigProvider.views.swipeBackEnabled(false);
	$ionicConfigProvider.scrolling.jsScrolling(true);

	// STATE MACHINE //
  $stateProvider

  .state('start-page', {
    url: "/start-page",
	cache: false,
    templateUrl: "views/auth/start-page.html",
    controller: 'loginCtrl'
  })

  .state('no-account-page', {
    url: "/no-account-page",
    templateUrl: "views/auth/no-account-page.html",
    controller: 'loginCtrl'
  })

  .state('start-register-page', {
    url: "/start-register-page",
    templateUrl: "views/auth/start-register-page.html",
    controller: 'CreateAccountCtrl'
  })
  
  .state('finish-register-page', {
    url: "/finish-register-page",
    templateUrl: "views/auth/finish-register-page.html",
    controller: 'CreateAccountCtrl'
  })

  .state('app', {
    url: "/app",
    abstract: true,
    templateUrl: "views/app/side-menu.html",
    controller: 'AppCtrl'
  })

  // APP HOME
  
  
    .state('app.search', {
    url: "/search",
    views: {
      'menuContent': {
		cache: false,
        templateUrl: "views/app/search.html",
		controller: 'SearchCtrl'
      }
    }
  })
  .state('app.searchquery', {
    url: "/searchquery/:input/:startResult/:endResult",
    views: {
      'menuContent': {
        templateUrl: "views/app/searchquery.html",
		controller: 'SearchQueryCtrl'
      }
    }
  })
  .state('app.qrscanner', {
    url: "/qrscanner",
    views: {
      'menuContent': {
		cache: false,
        templateUrl: "views/app/qrscanner.html", 
		controller: 'QrScannerCtrl'
      }
    }
  })
    .state('app.home', {
      url: "/home",
      views: {
        'menuContent': {
		  cache: false,	
          templateUrl: "views/app/home.html",
          controller: 'HomeCtrl'
        }
      }
    })
	.state('app.map', {
      url: "/map",
      views: {
        'menuContent': {
		  cache: false,	
          templateUrl: "views/app/map.html",
          controller: 'MapCtrl'
        }
      }
    })
	.state('app.transactions', {
      url: "/transactions/:startResult/:endResult",
      views: {
        'menuContent': {
          templateUrl: "views/app/transactions.html",
          controller: 'TransactionsCtrl'
        }
      }
    })
  .state('app.transaction', {
    url: "/transaction/:transactionId",
    views: {
      'menuContent': {
        templateUrl: "views/app/transaction.html",
        controller: 'TransactionCtrl'
      }
    }
  })
  .state('app.chargepoint', {
    url: "/chargepoint/:chargePointId",
    views: {
      'menuContent': {
        templateUrl: "views/app/chargepoint.html",
        controller: 'ChargepointCtrl'
      }
    }
  })
  .state('app.settingsgeneral', {
    url: "/settingsgeneral",
    views: {
      'menuContent': {
        templateUrl: "views/app/generalsettings.html",
        controller: 'SettingsCtrl'
      }
    }
  })
   .state('app.settingsuser', {
    url: "/settingsuser",
    views: {
      'menuContent': {
        templateUrl: "views/app/usersettings.html",
        controller: 'SettingsCtrl'
      }
    }
  })
   .state('app.settingsfilter', {
    url: "/settingsfilter",
    views: {
      'menuContent': {
        templateUrl: "views/app/filtersettings.html",
        controller: 'SettingsCtrl'
      }
    }
  })
  .state('app.transactionsettingspaypal', {
    url: "/transactionsettingspaypal/:chargePointId/:channelsAvailable/:startTariff/:kWhTariff/:minuteTariff",
	views: {
      'menuContent': {
        templateUrl: "views/app/transactionsettingspaypal.html",
        controller: 'TransactionsettingsCtrl'
      }
    }
  })
  .state('app.transactionsettingsinvoice', {
    url: "/transactionsettingsinvoice/:chargePointId/:channelsAvailable/:startTariff/:kWhTariff/:minuteTariff",
	views: {
      'menuContent': {
        templateUrl: "views/app/transactionsettingsinvoice.html",
        controller: 'TransactionsettingsCtrl'
      }
    }
  })
  .state('app.transactionsettingsfree', {
    url: "/transactionsettingsfree/:chargePointId/:channelsAvailable/:startTariff/:kWhTariff/:minuteTariff",
	views: {
      'menuContent': {
        templateUrl: "views/app/transactionsettingsfree.html",
        controller: 'TransactionsettingsCtrl'
      }
    }
  })
  .state('app.about', {
    url: "/about",
	views: {
      'menuContent': {
        templateUrl: "views/app/about.html",
        controller: 'SettingsCtrl'
      }
    }
  })
  .state('app.aboutapp', {
    url: "/aboutapp",
	views: {
      'menuContent': {
        templateUrl: "views/app/aboutApp.html",
		controller: 'infoCtrl'
      }
    }
  })

  ;// if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/start-page');
})

.service('registerData', function () {
     var registerData = {
        	creditorId: '',
			creditorBillingAccountName: '',	
			creditorBillingAccountAddress: '',	
			creditorBillingAccountZipCode: '',	
			creditorBillingAccountCity: '',	
			creditorBillingAccountCountryCode: '',	
			directDebitMandateId: '',
			invoiceDay: '',	
			directDebitDay: '',	
			conditionsUrl: '',	
			provider: '',
			cardExternalId: ''		
    };
    return registerData;
})

.service('appData', function () {
     var appData = {
        	uuid: '',
			platform: '',
			platformVersion: '',			
			deviceName: '',	
			deviceModel: '',
			cordova: '',	
			appVersion: '',
			colsStartUp: '',
			forcedProvider: '',
			style: 'templates/lms/'
    };
    return appData;
})

.service('intervalTransactionData', function () {
     var intervalTransactionData = {
        	transactionId: '',
			transactionStatus: '',	
			chargePointId: '',	
			chargePointVisibleId: '',	
			chargePointName: '',	
			chargePointAddress: '',	
			chargePointZipCode: '',
			chargePointCity: '',	
			chargePointCountryCode: '',	
			channel: '',	
			startDate: '',
			endDate: '',		
			updateDate: '',	
			energyDelivered: '',
			vat: '',
			totalAmount: '',
			paymentMethod: ''
    };
    return intervalTransactionData;
})

.service('intervalHomeData', function () {
	var intervalHomeData = {
			transactionId: '',
			transactionStatus: 'committed',	
			energyDelivered: '',
			duration: ''
    };
    return intervalHomeData;
})

.factory('intervalCallback', function($state, $http, appData, intervalHomeData, intervalTransactionData, general, $rootScope, convert) {
	var modify = {};

	modify.home = function(interruptName) {
		$http({
				url: general.server(),
				method: "POST",
				data: {action:'getTransactions',parameters:{token:window.localStorage['token'], version: appData.appVersion, deviceId: appData.uuid, mode: "customerTransactionsAll", startResult: 0, endResult: 1}},
				headers: {'Content-Type': 'application/json'}
			  }).success(function (data, status, headers, config) {
					if (status == 200 || status == 304) {
						if (data['status'] == "valid") {
							if (data['transactions'].length > 0) {        	
								intervalHomeData.transactionId 		= data['transactions'][0].transactionId;
								intervalHomeData.transactionStatus 	= data['transactions'][0].transactionStatus;	
								intervalHomeData.energyDelivered	= convert.energy((data['transactions'][0].energyDelivered), true) + 'h';
								intervalHomeData.duration			= convert.time((Math.floor(Date.now()/1000) - data['transactions'][0].startDate), true);
								$rootScope.$emit(interruptName);
							}
							else { // no transaction(s)       	
								intervalHomeData.transactionStatus 		= 'committed';	
								$rootScope.$emit(interruptName);
							}
						}
						else {
							general.softlogout();
						}
					}
				}).error(function (data, status, headers, config) {
					//alert(status);
					//alert("fout");
				});
	}
	modify.transaction = function(interruptName) {
		$http({
		url: general.server(),
		method: "POST",
		data: {action:'getTransactions',parameters:{token:window.localStorage['token'], version: appData.appVersion, transactionIds: [intervalTransactionData.transactionId], deviceId: appData.uuid, mode: "transactionIds", startResult: 0, endResult: 1}},
		headers: {'Content-Type': 'application/json'}
	  }).success(function (data, status, headers, config) {
			if (status == 200 || status == 304) {
				if (data['status'] == "valid") {
					if (data['transactions'].length > 0) {
						intervalTransactionData.loading =					'loaded';
						intervalTransactionData.chargePointId =  			data['transactions'][0].chargePointId;	
						intervalTransactionData.chargePointVisibleId =  	data['transactions'][0].chargePointVisibleId;	
						intervalTransactionData.transactionStatus =  		data['transactions'][0].transactionStatus;	
						intervalTransactionData.chargePointAddress = 		data['transactions'][0].chargePointAddress;
						intervalTransactionData.chargePointZipCode = 		data['transactions'][0].chargePointZipCode;
						intervalTransactionData.chargePointCity =    		data['transactions'][0].chargePointCity;	
						intervalTransactionData.channel =  					data['transactions'][0].channel;	
						intervalTransactionData.startDate = 				data['transactions'][0].startDate;
						intervalTransactionData.endDate =					data['transactions'][0].endDate;			
						intervalTransactionData.energyDelivered = 			data['transactions'][0].energyDelivered;
						intervalTransactionData.vat = 						data['transactions'][0].vat;
						intervalTransactionData.totalAmount = 				data['transactions'][0].totalAmount;
						intervalTransactionData.paymentMethod =				data['transactions'][0].paymentMethod;
						$rootScope.$emit(interruptName);
					}
				}
				else if (data['status'] == "versionTooLow") {
					general.versionToLow(); 
				}
				else {
					intervalTransactionData.loading = 	'error';
					$rootScope.$emit(interruptName);
				}
			}
		}).error(function (data, status, headers, config) {
			intervalTransactionData.loading = 	'error';
			$rootScope.$emit(interruptName);
		});
	}
			
  return modify; // returning this is very important
})

.factory('general', function($state, $ionicPopup, $filter, appData, intervalDataService, $ionicHistory, template, $timeout) {
  var modify = {};
  modify.versionToLow = function() {
	   var alertPopup = $ionicPopup.alert({
		 title: $filter('translate')('common.appversiontolow'),
		 template: $filter('translate')('common.updateapp')
	   });
	   alertPopup.then(function(res) {
		  modify.logout();
	   });
  }
  modify.softlogout = function() {
	    appData.coldStartUp = true;
		intervalDataService.stop("homeInterval");
		intervalDataService.stop("transactionInterval");
		$ionicHistory.clearHistory();
		$ionicHistory.clearCache();
		$state.go('start-page'); 
  }
  modify.logout = function() {
	    intervalDataService.stop("homeInterval");
		intervalDataService.stop("transactionInterval");
		window.localStorage['token'] = null;
		window.localStorage['login'] = false;
		window.localStorage['username'] = "";
		window.localStorage['provider'] = "";
		$ionicHistory.clearHistory();
		$ionicHistory.clearCache();
		appData.coldStartUp == false;
		$state.go('start-page'); 
  }
  modify.alert = function (title, text) {
	   var alertPopup = $ionicPopup.alert({
		 title: title,
		 template: text
	   });
	   alertPopup.then(function(res) {
		  
	   });
  }
  modify.toast = function (title, duration) {
	  if (appData.platform != "Windows") {
		  window.plugins.toast.showWithOptions(
			{
				message: title,
				duration: duration, // short is 2000 ms. "long" is 4000ms. Or specify the nr of ms yourself. 
				position: "bottom",
				addPixelsY: -40  // added a negative value to move it up a bit (default 0) 
			}
		  );
	  }
	  else {
		  alert(title);
	  }
  }
  modify.hideToast = function () {
	  if (appData.platform != "Windows") {
		window.plugins.toast.hide();
	  }
  }
  modify.server  = function () {
	if (window.localStorage['testserver'] == "true") {
		return window.localStorage['testservervalue']; 
	}
	else {
		return 'https://www.evc-net.com/api/app'; //'https://www.evc-net.com/Services/JSON/AppService.thr'
	}
  }
  modify.keepScreenOn  = function (screenOn) {
	if (appData.deviceName != "Test Pc" && appData.deviceName != "") {
		if (screenOn) {
			keepscreenon.enable();
		}
		else {
			keepscreenon.disable();
		}
	}
	else {
		console.log('keep screen on');
	}
  }
  return modify; // returning this is very important
})

.factory('convert', function($filter) {
  var modify = {};
  modify.time = function(time, withhtml) {
	  if (time >= 0) {
		if (time / 3600 >= 1) {
			if (withhtml) {
				if (Math.round(time/3600) < 999) {
					return (Math.round(time/3600) + " <small>u</small>");
				}
				else {
					return "> 999 <small>u</small>";
				}
			}
			else {
				var string = "";
				string += Math.floor(time/3600) + " u, ";
				time -= Math.floor(time/3600) * 3600;
				string += Math.floor(time/60) + " min " + $filter('translate')('common.and') + " ";
				time -= Math.floor(time/60) * 60;
				string += time + "s";
				return string;
			}
		}
		else if (time / 60 >= 1) {
			if (withhtml) {
				return (Math.round(time/60) + " <small>min</small>");
			}
			else {
				var string = "";
				string += Math.floor(time/60) + " min " + $filter('translate')('common.and') + " ";
				time -= Math.floor(time/60) * 60;
				string += time + "s";
				return string;
			}
		}
		else {
			if (withhtml) {
				return (time + " <small>s<small>");
			}
			else {
				return (time + " s");
			}
		}
	}
	else {
		return $filter('translate')('common.unknown');
	}
  }
  modify.hours = function(time) {
	  if (time >= 0 && time != null) {
		var d = new Date(time*1000);
		var str1 = "" + d.getHours();
		var pad1 = "00"
		var hours = pad1.substring(0, pad1.length - str1.length) + str1;
		var str2 = "" + d.getMinutes();
		var pad2 = "00"
		var mins = pad2.substring(0, pad2.length - str2.length) + str2;
		return hours + ":" + mins;
	  }
	  else {
		return "";
	  }	  
  }
  modify.date = function(time) {
	  if (time >= 0 && time != null) {
		var d = new Date(time*1000);
		var str1 = "" + d.getDate()
		var pad1 = "00"
		var days = pad1.substring(0, pad1.length - str1.length) + str1;
		var str2 = "" + (d.getMonth() + 1);
		var pad2 = "00"
		var months = pad2.substring(0, pad2.length - str2.length) + str2;
		var str3 = "" + d.getFullYear();
		var pad3 = "00"
		var years = pad3.substring(0, pad3.length - str3.length) + str3;
		return days + "-" + months + "-" + years;
	  }
	  else {
		return "onbekend";
	  }
  }
  modify.energy = function(energy, withhtml) {
		if (energy >= 0 && energy != null) {
			  if (energy >= 1000) {
					if (withhtml) {
						return (energy/1000).toFixed(2) + " <small>kW</small>";
					}
					else {
						return (energy/1000).toFixed(2) + " kW";
					}
			  }
		else if (energy < 1000 && energy >= 0) {
			if (withhtml) {
				return energy + " <small>W</small>";
			}
			else {
				return energy + " W";
			}
		}
		else {
			return "onbekend";
		}
	  }
  }
  modify.valuta = function(valuta, vat) {
	 if (valuta >= 0 && valuta != null && valuta != "null" && valuta != undefined) {
		if (window.localStorage['vat'] == 'true') { // nog invullen afhankelijk van btw instelling
			return "€" + (valuta * (vat + 1)).toFixed(2);
		}
		else {
			return "€" + (valuta).toFixed(2);
		}
	}
	else {
		return false;
	}
  }
  modify.chargepointAvailable = function(channelsUnknown, channelsAvailable, channelsOccupied, channelsFailed) {
	if (channelsAvailable > 0 || channelsAvailable.length > 0) {
		return true;
	}
	else {
		return false;
	}
  }
  modify.chargepointOccupied = function(channelsUnknown, channelsAvailable, channelsOccupied, channelsFailed) {
	if (modify.chargepointAvailable(channelsUnknown, channelsAvailable, channelsOccupied, channelsFailed) == true) {
		return false;
	}
	else if ((channelsOccupied > 0) || (channelsOccupied.length > 0)) {
		return true;
	}
	else {
		return false;
	}
  }
  modify.chargepointUnknown = function(channelsUnknown, channelsAvailable, channelsOccupied, channelsFailed) {
	if (modify.chargepointAvailable(channelsUnknown, channelsAvailable, channelsOccupied, channelsFailed) == true || modify.chargepointOccupied(channelsUnknown, channelsAvailable, channelsOccupied, channelsFailed) == true) {
		return false;
	}
	else if ((channelsUnknown > 0) || (channelsUnknown.length > 0)) {
		return true;
	}
	else {
		return false;
	}
  }
  modify.chargepointFailed = function(channelsUnknown, channelsAvailable, channelsOccupied, channelsFailed) {
	if (modify.chargepointAvailable(channelsUnknown, channelsAvailable, channelsOccupied, channelsFailed) == true || modify.chargepointOccupied(channelsUnknown, channelsAvailable, channelsOccupied, channelsFailed) == true || modify.chargepointUnknown(channelsUnknown, channelsAvailable, channelsOccupied, channelsFailed) == true) {
		return false;
	}
	else {
		return true;
	}
  }
  modify.chargepointDistance = function(meters, withhtml) {
	if (meters < 1000) {
		if (withhtml == true) {
			return meters + "<small> m</small>";
		}
		else {
			return meters + " " + $filter('translate')('common.meter');
		}
	}
	else if (meters < 100000) {
		if (withhtml == true) {
			return Math.round(meters/1000) + "<small> km</small>";
		}
		else {
			return Math.round(meters/1000) + " " + $filter('translate')('common.kilometres');
		}
	}
	else {
		if (withhtml == true) {
			return ">99<small> km</small>";
		}
		else {
			return Math.round(meters/1000) + " " + $filter('translate')('common.kilometres');
		}
	}
  }
 modify.openStatus = function (status) {
	if (status == "" || status == null) {
		return $filter('translate')('chargepoint.open');
	}
	else {
		return status;
	}
 }
 modify.availability = function (status) {
	if (status == true) {
		return "available";
	}
	else {
		return "all";
	}
 }
 modify.statusText = function(status) {
	if (status == 'pendingServerStopRequest') {
		return $filter('translate')('status.pendingServerStopRequest');
	}
	else if (status == 'finished') {
		return $filter('translate')('status.finished');
	}
	else if (status == 'committed') {
		return $filter('translate')('status.committed');
	}
	else if (status == 'notStarted') {
		return $filter('translate')('status.notStarted');
	}
	else if (status == 'pendingServerStartRequest') {
		return $filter('translate')('status.pendingServerStartRequest');
	}
	else if (status == 'charging') {
		return $filter('translate')('status.charging');
	}
	else if (status == 'chargingVehicleFull') {
		return $filter('translate')('status.chargingVehicleFull');
	}
	else if (status == 'validatingPayment') {
		return $filter('translate')('status.validatingPayment');
	}
	else if (status == 'paymentFailed') {
		return $filter('translate')('status.paymentFailed');
	}
 }
 modify.connectorString = function (string) {
	if (string == 'IEC-62196-T2') {
		return "Type 2";
	}
	else if (string == 'DOMESTIC-F') {
		return "Schuko";
	}
	else {
		return string;
	}
 }
  return modify; // returning this is very important
})

.factory('notificationHandler', function() {
  var modify = {};
  modify.onNotification = function(e) {
		alert(e.event);
	   switch( e.event )
		{
		case 'registered':
			if ( e.regid.length > 0 )
			{
				alert("regID = " + e.regid);
			}
		break;

		case 'message':
			// if this flag is set, this notification happened while we were in the foreground.
			// you might want to play a sound to get the user's attention, throw up a dialog, etc.
			if ( e.foreground )
			{
				alert('FOREGROUND NOTIFICATION');
				// on Android soundname is outside the payload.
				// On Amazon FireOS all custom attributes are contained within payload
				var soundfile = e.soundname || e.payload.sound;
				// if the notification contains a soundname, play it.
				var my_media = new Media("/android_asset/www/"+ soundfile);
				my_media.play();
			}
			else
			{  // otherwise we were launched because the user touched a notification in the notification tray.
				if ( e.coldstart )
				{
					alert('COLDSTART NOTIFICATION');
				}
				else
				{
					alert('BACKGROUND NOTIFICATION');
				}
			}

		   alert(e.payload.message);
			   //Only works for GCM
		   alert(e.payload.msgcnt);
		   //Only works on Amazon Fire OS
		   alert(e.payload.timeStamp);
		break;

		case 'error':
			alert(e.msg);
		break;

		default:
			alert('Unknown, an event was received and we do not know what it is');
		break;
	  }
  }
  return modify; // returning this is very important
})

.factory('notification', function(notificationHandler) {
  var modify = {};
  modify.init = function() {
		pushNotification = window.plugins.pushNotification;
		if (device.platform == 'android' || device.platform == 'Android' || device.platform == "amazon-fireos" ){
			pushNotification.register(
			modify.successHandler,
			modify.errorHandler,
			{
				"senderID":"370321398943",
				"ecb":"notificationHandler.onNotification"
			});
		}
  }
  modify.successHandler = function(result) {
		alert('result = ' + result);
  }
  modify.errorHandler = function(error) {
		alert('error = ' + error);
  }

  return modify; // returning this is very important
})

.factory('template', function($css, appData) {
  var modify = {};
  modify.setTemplate = function() {
		$css.removeAll();
		if (window.localStorage['provider'].toLowerCase() == "ecotap") { // ecotap template
			$css.add('./templates/ecotap/style.css');
			appData.style = "templates/ecotap/";
			if(ionic.Platform.platform() == "android"){
				StatusBar.backgroundColorByHexString("#548534");
			}
		}
		else if (window.localStorage['provider'].toLowerCase() == "edf luminus") { // EDF Luminus template
			$css.add('./templates/edfluminus/style.css');
			appData.style = "templates/edfluminus/";
			if(ionic.Platform.platform() == "android"){
				StatusBar.backgroundColorByHexString("#152654");
			}
		}
		else if (window.localStorage['provider'].toLowerCase() == "power station") { // Power Station
			$css.add('./templates/powerstation/style.css');
			appData.style = "templates/powerstation/";
			if(ionic.Platform.platform() == "android") {
				StatusBar.backgroundColorByHexString("#a12228");
			}
		}
		else if (window.localStorage['provider'].toLowerCase() == "entega") { // Power Station
			$css.add('./templates/entega/style.css');
			appData.style = "templates/entega/";
			if(ionic.Platform.platform() == "android") {
				StatusBar.backgroundColorByHexString("#f25a1a");
			}
		}
		else if (window.localStorage['provider'].toLowerCase() == "alewijnse") { // Power Station
			$css.add('./templates/alewijnse/style.css');
			appData.style = "templates/alewijnse/";
			if(ionic.Platform.platform() == "android") {
				StatusBar.backgroundColorByHexString("#006e51");
			}
		}
		else if (window.localStorage['provider'].toLowerCase() == "greencrowd") { // Greencrowd
			$css.add('./templates/greencrowd/style.css');
			appData.style = "templates/greencrowd/";
			if(ionic.Platform.platform() == "android") {
				StatusBar.backgroundColorByHexString("#00b955");
			}
		}
		else if (window.localStorage['provider'].toLowerCase() == "abl") { // Greencrowd
			$css.add('./templates/abl-sursum/style.css');
			appData.style = "templates/abl-sursum/";
			if(ionic.Platform.platform() == "android") {
				StatusBar.backgroundColorByHexString("#478488");
			}
		}
		else { // default template
			$css.add('./templates/lms/style.css');
			appData.style = "templates/lms/";
			if(ionic.Platform.platform() == "android"){
				StatusBar.backgroundColorByHexString("#346d9e");
			}
		}
  }
  return modify; // returning this is very important
})

;