angular.module('lms.controllers').controller('CreateAccountCtrl', ['$scope', '$state', '$http', '$ionicScrollDelegate', 'registerData', 'general', 'gps', 'appData', '$filter', 
																	function($scope, $state, $http, $ionicScrollDelegate, registerData, general, gps, appData, $filter){
	// Declaration scope variables
	$scope.providers = [];
	$scope.selectedProvider = '';
	$scope.providerIsLoading = true;
	$scope.startLoadingStartRegistration =	false;
	$scope.startLoadingFinishRegistration = false;
	$scope.register = registerData;
	$scope.salutation = "male";
	$scope.country = "NL";
	$scope.timeZone = "Europe/Amsterdam";
	$scope.billingAccountName = "";
	$scope.mobile = "";
	$scope.phone = "";
	$scope.registerError = false;
	
	// error vars
	$scope.firstNameError = "";
	$scope.lastNameError = "";
	$scope.streetError = "";
	$scope.streetNumberError = "";
	$scope.streetNumberExtError = "";
	$scope.zipcodeError = "";
	$scope.cityError = "";
	$scope.phoneError = "";
	$scope.mobileError = "";
	$scope.emailError = "";
	$scope.passwordError = "";
	$scope.accountNumberError = "";
	$scope.biccodeError = "";
	$scope.accountHolderError = "";
	
	// Scope functions
	$scope.showTerms = function() {
		if (ionic.Platform.isIOS()) {
			$scope.ref = cordova.InAppBrowser.open($scope.register.conditionsUrl, '_blank', 'closebuttoncaption=Close,toolbarposition=top,enableViewportScale=yes,location=no');
		}
		else {
			$scope.ref = cordova.InAppBrowser.open($scope.register.conditionsUrl, '_system', 'enableViewportScale=yes');
		}
	};
	  
	$scope.getProviders = function() {
	
		if (appData.forcedProvider != "") {
			//Only show the forcedProvider
			$scope.providers.push(appData.forcedProvider);
			console.log("Providers:" + $scope.providers);
			$scope.startLoadingStartRegistration = false;
			$scope.providerIsLoading = false;
			return;
		}
		
		$scope.parameters = {version: appData.appVersion, deviceId: appData.uuid};
		
		$http({
		url: general.server(),
		method: "POST",
		data: {action:'getProviders',parameters:$scope.parameters},
		headers: {'Content-Type': 'application/json'}
	  }).success(function (data, status, headers, config) {
			if (status == 200 || status == 304) {
				if (data['status'] == "valid") {
					angular.forEach(data['providers'],function(providers){
						 $scope.providers.push(providers);
					});
					console.log("Providers:" + $scope.providers);
					$scope.providerIsLoading = false;
				}
				else if (data['status'] == "versionTooLow") {
					general.versionToLow(); 
				}
				else if (data['status'] == "invalidRequest") {
					 general.alert($filter('translate')('common.fault'),$filter('translate')('login.cardAlreadyInUse'));
					//nog invullen -> invalid
				}
				else {
					general.softlogout();
				}
			}
			$scope.startLoadingStartRegistration = false;
		}).error(function (data, status, headers, config) {
			$scope.startLoadingStartRegistration = false;
		});
	};
	
	$scope.loadRegistrationInformation = function() {
		$scope.startLoadingStartRegistration = true; // show loading icon
		console.log(this.selectedProvider);
		if (this.requestCard == 'true') {
			$scope.parameters = {version: appData.appVersion, deviceId: appData.uuid, provider: this.selectedProvider};
			$scope.register.cardExternalId = "";
		}
		else {
			$scope.parameters = {version: appData.appVersion, deviceId: appData.uuid, cardExternalId: this.cardExternalId};	
			$scope.register.cardExternalId = this.cardExternalId;
		}
		
		$http({
		url: general.server(),
		method: "POST",
		data: {action:'startRegistration',parameters:$scope.parameters},
		headers: {'Content-Type': 'application/json'}
	  }).success(function (data, status, headers, config) {
			if (status == 200 || status == 304) {
				if (data['status'] == "valid") {
					$scope.startLoadingStartRegistration = false;
					$scope.register.creditorId = data['creditorId'];
					$scope.register.creditorBillingAccountName = data['creditorBillingAccountName'];
					$scope.register.creditorBillingAccountAddress = data['creditorBillingAccountAddress'];
					$scope.register.creditorBillingAccountZipCode = data['creditorBillingAccountZipCode'];
					$scope.register.creditorBillingAccountCity = data['creditorBillingAccountCity'];
					$scope.register.creditorBillingAccountCountryCode = data['creditorBillingAccountCountryCode'];
					$scope.register.directDebitMandateId = data['directDebitMandateId'];
					$scope.register.invoiceDay = data['invoiceDay'];
					$scope.register.directDebitDay = data['directDebitDay'];
					$scope.register.conditionsUrl = data['conditionsUrl'];	
					$scope.register.provider = data['provider'];	
					$state.go('finish-register-page');
				}
				else if (data['status'] == "versionTooLow") {
					general.versionToLow(); 
				}
				else if (data['status'] == "invalidRequest") {
					 general.alert($filter('translate')('common.fault'),$filter('translate')('login.cardAlreadyInUse'));
					//nog invullen -> invalid
				}
				else {
					general.softlogout();
				}
			}
			$scope.startLoadingStartRegistration = false;
		}).error(function (data, status, headers, config) {
			$scope.startLoadingStartRegistration = false;
		});
		
		
	};	
	
	$scope.updateaccountholder = function() {
		console.log(this.firstNameForm + " " + this.lastNameForm);
		if (this.firstNameForm != undefined && this.lastNameForm != undefined) {
			$scope.billingAccountName = this.firstNameForm + " " + this.lastNameForm;
		}
	}
	
	$scope.finishRegistration = function() {
		$scope.startLoadingFinishRegistration = true;
		$scope.registerError = false;
		$scope.emailConfirm = "";
		
		$scope.firstNameError = "";
		$scope.lastNameError = "";
		$scope.streetError = "";
		$scope.streetNumberError = "";
		$scope.streetNumberExtError = "";
		$scope.zipcodeError = "";
		$scope.cityError = "";
		$scope.countryError = "";
		$scope.timezoneError = "";
		$scope.phoneError = "";
		$scope.mobileError = "";
		$scope.emailError = "";
		$scope.passwordError = "";
		$scope.accountNumberError = "";
		$scope.biccodeError = "";
		$scope.accountHolderError = "";
	
		if (this.emailForm != this.emailCheckForm) {
			general.alert($filter('translate')('createaccount.error'), $filter('translate')('createaccount.errorgeneric'));
			$scope.startLoadingFinishRegistration = false;
			$scope.registerError = true;
			$scope.emailError = "different";
			return
		}
		if (this.passwordForm != this.passwordCheck) {
			general.alert($filter('translate')('createaccount.error'), $filter('translate')('createaccount.errorgeneric'));
			$scope.startLoadingFinishRegistration = false;
			$scope.registerError = true;
			$scope.passwordError = "different";
			return;
		}		
		
		window.localStorage['firstName'] = this.firstNameForm;
		window.localStorage['lastName'] = this.lastNameForm;
		window.localStorage['email'] = this.emailCheckForm;
		
		$http({
		url: general.server(),
		method: "POST",
		data: {action:'finishRegistration',parameters:{version: appData.appVersion, deviceId: appData.uuid, provider: $scope.register.provider, salutation: this.salutation, firstName: this.firstNameForm, lastName: this.lastNameForm, street: this.street, streetNumber: this.streetNumber, streetNumberExt: this.streetNumberExt, zipCode: this.zipCode, city: this.city, country: this.country, timeZone: this.timeZone, phone: this.phone.toString(), mobile: this.mobile.toString(), email: this.emailCheckForm, password: this.passwordCheck, billingAccountNo: this.billingAccountNo, billingAccountName: this.billingAccountName, billingAccountBIC: this.billingAccountBIC, directDebitAccepted: this.directDebitAccepted, directDebitMandateId: $scope.register.directDebitMandateId, remarks: "", conditionsAccepted: this.conditionsAccepted, cardExternalId: $scope.register.cardExternalId, loginAfterRegistration: true, platform: "android", locale: "nl_NL"}}, //TO DO vul juiste taal in
		headers: {'Content-Type': 'application/json'}
	  }).success(function (data, status, headers, config) {
			if (status == 200 || status == 304) {
				if (data['status'] == "valid") {
					window.localStorage['token'] = data['token'];
					window.localStorage['transactionsInProgress'] = false;
					window.localStorage['provider'] = $scope.register.provider;
					window.localStorage['login'] = true;
					window.localStorage['freeTransactionAvailable'] = true;
					window.localStorage['companyName'] = "onbekend"; // TODO: nederlands
					window.localStorage['customerType'] = "onbekend"; // TODO: nederlands
					$state.go('app.home'); 
				}
				else if (data['status'] == "versionTooLow") {
					$scope.startLoadingFinishRegistration = false;
					general.versionToLow(); 
				}
				else if (data['status'] == "invalid") {
					$scope.registerError = true;
					for (var i in data['errors']) {
						if (data['errors'][i].field == "firstName") {
							$scope.firstNameError = data['errors'][i].message;
						}
						else if (data['errors'][i].field == "lastName") {
							$scope.lastNameError = data['errors'][i].message;
						}
						else if (data['errors'][i].field == "street") {
							$scope.streetError = data['errors'][i].message;
						}
						else if (data['errors'][i].field == "streetNumber") {
							$scope.streetNumberError = data['errors'][i].message;
						}
						else if (data['errors'][i].field == "streetNumberExt") {
							$scope.streetNumberExtError = data['errors'][i].message;
						}
						else if (data['errors'][i].field == "zipCode") {
							$scope.zipcodeError = data['errors'][i].message;
						}
						else if (data['errors'][i].field == "city") {
							$scope.cityError = data['errors'][i].message;
						}
						else if (data['errors'][i].field == "phone") {
							$scope.phoneError = data['errors'][i].message;
						}
						else if (data['errors'][i].field == "mobile") {
							$scope.mobileError = data['errors'][i].message;
						}
						else if (data['errors'][i].field == "email") {
							$scope.emailError = data['errors'][i].message;
						}
						else if (data['errors'][i].field == "password") {
							$scope.passwordError = data['errors'][i].message;
						}
						else if (data['errors'][i].field == "billingAccountNo") {
							$scope.accountNumberError = data['errors'][i].message;
						}
						else if (data['errors'][i].field == "billingAccountBIC") {
							$scope.biccodeError = data['errors'][i].message;
						}
						else if (data['errors'][i].field == "billingAccountName") {
							$scope.accountHolderError = data['errors'][i].message;
						}
					}
					$scope.startLoadingFinishRegistration = false;
					general.alert($filter('translate')('createaccount.error'), $filter('translate')('createaccount.errorgeneric'));
				}
				else {
					$scope.registerError = true;
					$scope.startLoadingFinishRegistration = false;
					general.softlogout();
				}
			}

		}).error(function (data, status, headers, config) {
			$scope.startLoadingFinishRegistration = false;
		});
	};
	
	$scope.refreshScroller = function() {
		$ionicScrollDelegate.resize();
	};
	
	$scope.doSignUp = function(){
		console.log("doing sign up");
		$state.go('app.home');
	};
	
	$scope.test = function() {
		console.log("test");
	}
	
	$scope.showError = function(errorType, text) {
		if (errorType == "different") {
			general.alert($filter('translate')('createaccount.error'),$filter('translate')('createaccount.notdifferent1') + " " + $filter('translate')(text) + " " + $filter('translate')('createaccount.notdifferent2') );
		}
		else if (errorType == "taken") {
			general.alert($filter('translate')('createaccount.error'), $filter('translate')('createaccount.notdifferent1') + " " + $filter('translate')(text) + " " + $filter('translate')('createaccount.istaken'));
		}
		else if (errorType == "invalidFormat") {
			general.alert($filter('translate')('createaccount.error'), $filter('translate')('createaccount.notdifferent1') + " " + $filter('translate')(text) + " " + $filter('translate')('createaccount.invalid'));
		}
		else if (errorType == "customerExists") {
			general.alert($filter('translate')('createaccount.error'), $filter('translate')('createaccount.customerexists'));
		}
		else {
			general.alert($filter('translate')('createaccount.error'), $filter('translate')('createaccount.genericerror'));
		}
	};
	
	$scope.changeProvider = function () {
		$scope.selectedProvider = this.selectedProvider;
	}

	// Init function
	$scope.init = function() {
		gps.determineLocation(false, false);
		$scope.getProviders();
	}
	
}]);