angular.module('lms.controllers').controller('HomeCtrl', ['$scope', '$ionicHistory', '$timeout', 'convert', '$state', '$location', '$rootScope', 'general', 'gps', 'appData', 'intervalDataService', 'intervalHomeData', '$ionicSideMenuDelegate',
															function($scope, $ionicHistory, $timeout, convert, $state, $location, $rootScope, general, gps, appData, intervalDataService, intervalHomeData, $ionicSideMenuDelegate) {
	// Declaration scope variables
	$scope.transactionStatus = 'committed';
	$scope.energyDelivered = "";
	$scope.duration = "";
	$scope.transactionId;
	$scope.stop = true;
	$scope.results = window.localStorage['results'];
	$scope.guest = window.localStorage['guest'];
	
	// Events
	$scope.$on('$destroy',function(){
        intervalDataService.stop("homeInterval");   
	});
	
	$scope.$on('$ionicView.enter', function(){
	  intervalDataService.start("homeInterval", 2000);
	});
	
	$scope.$on('$ionicView.leave', function(){
	  intervalDataService.stop("homeInterval");  
	});
	
	$scope.register = function() {
		$state.go('no-account-page'); 
		
		$timeout(function() {
			$state.go('start-register-page'); 
		}, 1);
	}
	
	//event from intervalDataService
	intervalDataService.newIntervalDataCallback('homeInterval', $scope, function() { // new
		if (intervalHomeData.transactionStatus == 'committed') {
			intervalDataService.stop("homeInterval"); // stop requesting information
		}
		else if (intervalHomeData.transactionStatus == 'charging') {
			intervalDataService.start("homeInterval",60000);
		}
		else {
			intervalDataService.start("homeInterval",5000);
		}
		$scope.transactionId = intervalHomeData.transactionId;
		$scope.transactionStatus = intervalHomeData.transactionStatus;
		$scope.energyDelivered = intervalHomeData.energyDelivered;
		$scope.duration = intervalHomeData.duration;
    });
	
	// Init function
	$scope.init = function() {
		if(ionic.Platform.platform() != "win32") {
			navigator.splashscreen.hide();
		}
		console.log(intervalHomeData.transactionStatus);
		gps.determineLocation(false, false);
		general.keepScreenOn(false);
		intervalDataService.start("homeInterval", 2000);
		console.log("init");
	}
}]);