angular.module('lms.controllers').controller('loginCtrl', ['$scope', '$ionicModal', '$ionicPopup', '$state', '$http', '$filter', 'general', '$timeout', 'template', 'gps', 'appData',
															function($scope, $ionicModal, $ionicPopup, $state, $http, $filter, general, $timeout, template, gps, appData) {
    // Declaration scope variables
    var loginPopup;
	var loginPopupOpen = false;
	var forgotPasswordPopup;
	$scope.busyLogin = false;
	$scope.invalidLogin = false;
	$scope.userLoginBusy = false;
	$scope.guestLoginBusy = false;
	$scope.forgotPasswordBusy = false;
	$scope.loginEmail = "";
	$scope.loginPassword = "";
	$scope.adminpower = true;
	$scope.forgotUsername = "";
	$scope.testservervalue = window.localStorage['testservervalue'];
	$scope.testserver;
	$scope.lmssuperadmin;
	
	// Scope functions
	$scope.update = function () {
		$scope.loginEmail = this.loginEmail;
		$scope.loginPassword = this.loginPassword;
		$scope.forgotUsername = this.forgotUsername;
	}
	
	$scope.loginGuest = function() {
		$scope.guestLoginBusy = true;
		$scope.login(null, "guest@lastmilesolutions.com", "guest1");
	}
	
	$scope.loginUser = function() {
		if ($scope.loginEmail == 'super@dmin.nl' && $scope.loginPassword =="Threeforce2013") { 
			window.localStorage['lmssuperadmin'] = true;
			$scope.lmssuperadmin = true;			
			$timeout( function(){  
				general.alert("Whoopee Admin Power", "Op deze telefoon heb je nu adminrechten.");
			}, 250);
			$scope.closeLoginPopup();
			return;
		}
		$scope.userLoginBusy = true;
		$scope.login(null, $scope.loginEmail, $scope.loginPassword);
	}
	
	$scope.login = function(token, username, password) {
		$scope.invalidLogin = false;
		$http({
		url: general.server(),
		method: "POST",
		data: {action:'login',parameters:{token:token, email: username, password: password, deviceId: appData.uuid, version: appData.appVersion, platform: "Android", locale: "nl_NL"}},
		headers: {'Content-Type': 'application/json'}
	  }).success(function (data, status, headers, config) {
			if (status == 200 || status == 304) {
				if (data['status'] == "valid") {
					console.log("http request valid");
					window.localStorage['token'] = data['token'];
					window.localStorage['transactionsInProgress'] = data['transactionsInProgress'];
					
					window.localStorage['transactionsInProgress'] = data['transactionsInProgress'];
					window.localStorage['login'] = true;
					window.localStorage['freeTransactionAvailable'] = data['freeTransactionAvailable'];
					window.localStorage['firstName'] = data['firstName'];
					window.localStorage['lastName'] = data['lastName'];
					window.localStorage['companyName'] = data['companyName'];
					window.localStorage['provider'] = data['provider'];
					
					if (data['email'] == "guest@lastmilesolutions.com") {
						window.localStorage['firstName'] = $filter('translate')('login.guest');
						window.localStorage['lastName'] = "";
						window.localStorage['email'] = "";
						window.localStorage['guest'] = true;
						window.localStorage['customerType'] = $filter('translate')('common.guestaccount');
					}
					else {
						window.localStorage['guest'] = false;
						window.localStorage['email'] = data['email'];
						window.localStorage['customerType'] = data['customerType'];
						template.setTemplate();
					}
					$scope.closeLoginPopup();
					$state.go('app.home'); 
					$timeout( function(){ 
						$scope.busyLogin = false;
						$scope.invalidLogin = false;
						$scope.userLoginBusy = false;
						$scope.guestLoginBusy = false;
						$scope.forgotPasswordBusy = false;
					}, 1000);
				}
				else if (data['status'] == "invalid") {
					$scope.userLoginBusy = false;
					$scope.guestLoginBusy = false;
					$scope.busyLogin = false;
					if (token == null) {
						$scope.invalidLogin = true;
					}
				}
				else if (data['status'] == "versionTooLow") {
					$scope.userLoginBusy = false;
					$scope.guestLoginBusy = false;
					$scope.busyLogin = false;
					$scope.loading = false;
					$scope.closeLoginPopup();
					general.versionToLow(); 
				}
				else { 
					$scope.loading = false;
					$scope.busyLogin = false;
					$scope.closeLoginPopup();
					general.softlogout();
				}
			}
		}).error(function (data, status, headers, config) {
			$scope.userLoginBusy = false;
			$scope.guestLoginBusy = false;
			$scope.busyLogin = false;
		});
	}

	$scope.retrievePassword = function () {
		$scope.forgotPasswordBusy = true;
		$http({
			url: general.server(),
			method: "POST",
			data: {action:'retrievePassword',parameters:{version: appData.appVersion, deviceId: appData.uuid, email: $scope.forgotUsername}},
			headers: {'Content-Type': 'application/json'}
		  }).success(function (data, status, headers, config) {
				forgotPasswordPopup.close();
				$timeout( function() { 
					if (status == 200 || status == 304) {
						
						if (data['status'] == "valid") { // willen niet dat er gezien wordt dat email adres niet bestaat dus ook gewoon zeggen dat het verzonden is
							general.alert($filter('translate')('common.successful'),$filter('translate')('login.forgotPasswordInstructions'));
						}
						else if (data['status'] == "invalid") {
							general.alert($filter('translate')('common.failed'),$filter('translate')('login.forgotPasswordInstructionsfailed'));
						}
						else if (data['status'] == "versionTooLow") {
							general.versionToLow(); 
						}
						else {
							general.alert("Error","Something went wrong...");
						}
					}
					 $scope.forgotPasswordBusy = false;
				}, 200);
			}).error(function (data, status, headers, config) {
				$scope.forgotPasswordBusy = false;
			});
	}

	$scope.showPrivacyPolicy = function() {
		$scope.privacy_policy_modal.show();
	};

	$scope.showTerms = function() {
		$scope.ref = cordova.InAppBrowser.open('https://www.evc-net.com/Register/Conditions', '_system');
	};
	  
	$scope.showAdminPanel = function() {
		$scope.adminpanelmodal.show();
	};

	$scope.hideAdminModel = function () {
		$scope.adminpanelmodal.hide();
	}
	
	$scope.testserverOption = function () {
		if (this.testserver == true) {
			$scope.testserver = true;
			window.localStorage['testserver'] = true;
			
		}
		else {
			$scope.testserver = false;
			window.localStorage['testserver'] = false;
		}
	}
	
	$scope.disableadmin = function () {
		$scope.testserver = false;
		window.localStorage['testserver'] = false;
		window.localStorage['lmssuperadmin'] = false;
		$scope.lmssuperadmin = false;
		$scope.hideAdminModel();
	}
	
	$scope.changeTemplate = function (provider) {
		window.localStorage['provider'] = provider;
		template.setTemplate(); // Set right template
	}
	
	$scope.updatetestserver = function () {
		window.localStorage['testservervalue'] = this.testservervalue;
	}

	$scope.showForgotPassword = function() {
		$scope.closeLoginPopup();
		$timeout( function(){ 
			  console.log("open forgot password popup");
			forgotPasswordPopup = $ionicPopup.show({
				template: '<a class="button button-icon icon ion-ios-close-outline right-top" ng-click="closeForgotPasswordPopup()"></a><form name="login_form" class="" novalidate><label class="item item-input"><input type="email" placeholder="' + $filter('translate')('login.username') + '" name="formUsernameForgot" ng-model="forgotUsername" ng-change="update()" required></label></form><button type="submit" class="login button button-block" ng-click="retrievePassword()" ng-disabled="login_form.$invalid"><p ng-show="forgotPasswordBusy == false">{{\'login.forgotpassword\' | translate }}</p><ion-spinner ng-show="forgotPasswordBusy == true"></ion-spinner></button>',
				title: "<b>" + $filter('translate')('login.forgotpassword') + "</b>",
				subTitle: '<div class="modalSpacer">' + $filter('translate')('login.forgotPasswordInfo') + '</div>',
				scope: $scope
			});
		}, 250);

	};

	$scope.requestNewPassword = function() {
		console.log("requesting new password");
	};

	$scope.closeForgotPasswordPopup = function() {
		forgotPasswordPopup.close();
		$timeout( function(){ 
			  $scope.showLoginPopup();
		}, 250);
	};  

	$scope.showLoginPopup = function() {
		if (loginPopupOpen == false) {
			loginPopupOpen = true
			console.log("open login popup");
		  loginPopup = $ionicPopup.show({
			template: '<a class="button button-icon icon ion-ios-close-outline right-top" ng-click="closeLoginPopup()"></a><form name="login_form" class="" novalidate><label class="item item-input" ng-class="{\'invalidLogin \' : invalidLogin}"><input type="email" placeholder="' + $filter('translate')('login.username') + '" ng-init="loginEmail = \'\'" ng-model="loginEmail" ng-change="update()" required></label><div class="modalSpacer"></div><label class="item item-input" ng-class="{\'invalidLogin \' : invalidLogin}" show-hide-container><input type="password" placeholder="' + $filter('translate')('login.loginpassword') + '" ng-init="loginPassword = \'\'" ng-model="loginPassword" ng-change="update()" required show-hide-input></label></form><button type="submit" class="login button button-block" ng-click="loginUser()" ng-disabled="login_form.$invalid"><p ng-show="userLoginBusy == false">{{\'login.login\' | translate }}</p><ion-spinner ng-show="userLoginBusy == true"></ion-spinner></button><div class="alternative-actions"><a class="forgot-password button button-clear button-block" ng-click="showForgotPassword()">{{\'login.forgotpassword\' | translate }}</a></div>',
			title: '<b>' + $filter('translate')('login.logintitle') + '</b>',
			subTitle: '<div class="modalSpacer">'  + $filter('translate')('login.loginsubtitle') +  '</div>',
			scope: $scope
		  });
		 }
	};

	$scope.closeLoginPopup = function() {
		if (loginPopupOpen == true) {
			$scope.invalidLogin = false;
			loginPopupOpen = false;
			loginPopup.close();
		}
	};
	
	$scope.closeAllPopups = function () {
		forgotPasswordPopup.close();
		$scope.closeLoginPopup();
	};
	
	// Init function
	$scope.init = function() {
		console.log("init login");
		gps.determineLocation(false, false);
		if (appData.coldStartUp == true || appData.coldStartUp == undefined) {
			console.log("cold start, try login");
			console.log(window.localStorage['token']);
			appData.coldStartUp = false;
			if (window.localStorage['token'] != false && window.localStorage['token'] != undefined && window.localStorage['token'] != 'null') {
				console.log("Whoop try to login");
				$scope.busyLogin = true;
				$timeout( function(){ 
					$scope.login(window.localStorage['token'], null, null);
				}, 250);
			}
		}
		else {
			$scope.busyLogin = false;
			console.log("show login field");
		}
		
		$timeout( function(){
			// Disable splash screen
			if(ionic.Platform.platform() != "win32"){
				navigator.splashscreen.hide();
			}
		}, 1000);

		if (window.localStorage['testserver'] == "true") {
			$scope.testserver = true;
		}
		else {
			$scope.testserver = false;
		}
		if (window.localStorage['lmssuperadmin'] == "true") {
			$scope.lmssuperadmin = true;
		}
		else {
			$scope.lmssuperadmin = false;
		}
		
		$ionicModal.fromTemplateUrl('views/partials/forgot-password.html', {
			scope: $scope,
			animation: 'slide-in-up'
		}).then(function(modal) {
			$scope.forgot_password_modal = modal;
		});
		
		$ionicModal.fromTemplateUrl('views/partials/privacy-policy.html', {
			scope: $scope,
			animation: 'slide-in-up'
		}).then(function(modal) {
			$scope.privacy_policy_modal = modal;
		});

		$ionicModal.fromTemplateUrl('views/partials/terms-of-service.html', {
			scope: $scope,
			animation: 'slide-in-up'
		}).then(function(modal) {
			$scope.terms_of_service_modal = modal;
		});

		$ionicModal.fromTemplateUrl('views/partials/adminpanel.html', {
			scope: $scope,
			animation: 'slide-in-up'
		}).then(function(modal) {
			$scope.adminpanelmodal = modal;
		});
	}
}]);