angular.module('lms.controllers').controller('SearchCtrl', ['$scope', '$state', '$ionicScrollDelegate', '$translate', '$filter', 'general', 'gps', '$http',
															function($scope, $state, $ionicScrollDelegate, $translate, $filter, general, gps, $http) {
	// Declaration of scope variables
	$scope.mylocationplaceholder = $filter('translate')('search.mylocationplaceholder');
	$scope.input = {};
	$scope.searchHistory = [];
	$scope.results = window.localStorage['results'];
	
	// Scope functions
	$scope.refreshSearchResults = function () {
		if((localStorage["searchHistory"]) != undefined && (localStorage["searchHistory"]) != "") {
				$scope.searchHistory = JSON.parse(localStorage["searchHistory"]);
				$scope.searchHistory.reverse();
		}
	}
	
	$scope.search = function() {
		if ($scope.input.searchString == "") {
			return;
		}
		if ($scope.input.location) {
			$state.go('app.searchquery', { "input": null, "startResult": 0, "endResult": $scope.results}); 
		}
		else {
			$state.go('app.searchquery', { "input": $scope.input.searchString, "startResult": 0, "endResult": $scope.results}); 
		}
	}
	
	$scope.searchInHistory = function(search) {
		$state.go('app.searchquery', { "input": search, "startResult": 0, "endResult": $scope.results}); 
	}
	
	$scope.refreshScroller = function() {
		$ionicScrollDelegate.resize();
	}
	
	$scope.filterSettings = function() {
		$state.go('app.settingsfilter'); 
	}
	
	$scope.emptyHistory = function() {
		localStorage["searchHistory"] = "";
		$scope.searchHistory = [];
	}
	
	$scope.clearSearchInput = function() {
		$scope.input.searchString = "";
		$scope.input.search = true;
		$scope.input.location = false;
		$scope.input.locationLoading = false;
		$scope.input.searchPlaceholder = $filter('translate')('search.searchplaceholder');
	}
	
	$scope.convertGpsToAddress = function(lat, lng) {
	  $http.get('https://maps.googleapis.com/maps/api/geocode/json?latlng=' + 
				lat + "," + lng + '&key=AIzaSyBjy--Xev355I5toH0BQBEkdsHCc1nmufA')
		.then(function(_results){
		   $scope.input.locationLoading = false;
		   $scope.input.searchString = _results.data.results[0].formatted_address;
		 }, 
		 function error(_error){
			$scope.input.locationLoading = false;
			$scope.input.searchString = $scope.mylocationplaceholder;
		 })
	}
	
	$scope.setLocation = function() {
		$scope.input.locationLoading = true;
		console.log("Set new location!");
		if (gps.isActual() != true) {
			gps.determineLocation(true, true);
			$scope.input.searchPlaceholder = $filter('translate')('search.tryingToLocate');
		}
		else {
			$scope.input.searchPlaceholder = "";
			$scope.convertGpsToAddress(gps.getLatitude(), gps.getLongitude());
		}
		$scope.input.search = false;
		$scope.input.location = true;
	}
	
	gps.newLocationCallback('newLocation', $scope, function() { // new GPS location
		if ($scope.input.locationLoading == true) {
			$scope.input.searchPlaceholder = "";
			$scope.convertGpsToAddress(gps.getLatitude(), gps.getLongitude());
		}	
     });
	
	// Init function
	$scope.init = function() {
		gps.determineLocation(true, false);
		$scope.refreshSearchResults();
		$scope.input.searchString = "";
		$scope.input.searchPlaceholder = $filter('translate')('search.searchplaceholder');
		$scope.input.search = true;
		$scope.input.location = false;
		$scope.input.locationLoading = false;
	}
}]);