angular.module('lms.controllers').controller('SettingsCtrl', ['$scope', '$ionicSideMenuDelegate', '$translate', 'gps', 'general', '$state', '$ionicScrollDelegate', '$timeout',
																function($scope, $ionicSideMenuDelegate, $translate, gps, general, $state, $ionicScrollDelegate, $timeout ) {
	//Declaration of scope variables
	$scope.setting = {};
	$scope.user = {};
		
	// Scope functions
	$scope.change = function(text, variable) {
		window.localStorage[text] = variable;
	};
	
	$scope.changeFilter = function(filterOption, addToFilter) {
		var tempArray = JSON.parse(window.localStorage['searchconnectorArray']);
		console.log(tempArray[0]);
		var filter = [];
		if (filterOption == 1) {
			filter.push("IEC-62196-T1");
			$scope.setting1 = addToFilter;
		}
		else if (filterOption == 2) {
			filter.push("IEC-62196-T2");
			$scope.setting2 = addToFilter;
		}
		else if (filterOption == 3) {
			filter.push("IEC-62196-T3A");
			filter.push("IEC-62196-T3C");
			$scope.setting3 = addToFilter;
		}
		else if (filterOption == 4) {
			filter.push("Chademo");
			$scope.setting4 = addToFilter;
		}
		else if (filterOption == 5) {
			filter.push("IEC-62196-T1-COMBO");
			filter.push("IEC-62196-T2-COMBO");
			$scope.setting5 = addToFilter;
		}
		else if (filterOption == 6) {
			filter.push("DOMESTIC-F");
			filter.push("DOMESTIC-A");
			filter.push("DOMESTIC-B");
			filter.push("DOMESTIC-C");
			filter.push("DOMESTIC-D");
			filter.push("DOMESTIC-E");
			filter.push("DOMESTIC-G");
			filter.push("DOMESTIC-H");
			filter.push("DOMESTIC-I");
			filter.push("DOMESTIC-J");
			filter.push("DOMESTIC-K");
			filter.push("DOMESTIC-L");
			$scope.setting6 = addToFilter;
		}
		else if (filterOption == 7) {
			filter.push("IEC-60309-2-single-16");
			filter.push("IEC-60309-2-three-16");
			filter.push("IEC-60309-2-three-32");
			filter.push("IEC-60309-2-three-64");
			$scope.setting7 = addToFilter;
		}
		else if (filterOption == 8) {
			filter.push("TESLA-R");
			filter.push("TESLA-S");
			$scope.setting8 = addToFilter;
		}
		
		if (addToFilter) {
			tempArray.push.apply(tempArray, filter);
		}
		else {
			tempArray = tempArray.filter( function( el ) {
			  return filter.indexOf( el ) < 0;
			});
		}
		
		window.localStorage['searchconnectorArray'] = JSON.stringify(tempArray);
		console.log(window.localStorage['searchconnectorArray']);
	}
	
	$scope.readFilterSettings = function () {
		
		if (window.localStorage['searchavailable'] == 'true') {
			$scope.setting.searchavailable = true;
		}
		else {
			$scope.setting.searchavailable = false;
		}
		if (window.localStorage['searchpaywithapp'] == 'true') {
			$scope.setting.searchpaywithapp = true;
		}
		else {
			$scope.setting.searchpaywithapp = false;
		}		
		
		$scope.setting.searchchargeEnergy = window.localStorage['searchchargeEnergy'];
		
		var tempArray = JSON.parse(window.localStorage['searchconnectorArray']);
		console.log("Read filter settings" + tempArray);
		if (tempArray.indexOf("IEC-62196-T1") >= 0) {
			$scope.setting.setting1 = true;
			console.log("IEC-62196-T1 == true");
		}	
		if (tempArray.indexOf("IEC-62196-T2") >= 0) {
			$scope.setting.setting2 = true;
			console.log("IEC-62196-T2 == true");
		}
		if (tempArray.indexOf("IEC-62196-T3A") >= 0) {
			$scope.setting.setting3 = true;
		}
		if (tempArray.indexOf("Chademo") >= 0) {
			$scope.setting.setting4 = true;
		}
		if (tempArray.indexOf("IEC-62196-T1-COMBO") >= 0) {
			$scope.setting.setting5 = true;
		}
		if (tempArray.indexOf("DOMESTIC-F") >= 0) {
			$scope.setting.setting6 = true;
		}
		if (tempArray.indexOf("IEC-60309-2-single-16") >= 0) {
			$scope.setting.setting7 = true;
		}
		if (tempArray.indexOf("TESLA-R") >= 0) {
			$scope.setting.setting8 = true;
		}
	}
	
	$scope.changeLanguage = function() {
		window.localStorage['setLanguage'] = $scope.setting.language;
		if ($scope.setting.language == "auto") {
			$translate.use(window.localStorage['language']);
		}
		else {
			$translate.use($scope.setting.language);
		}
	};
	
	$scope.resetFilter = function () {
		tempArray = ["IEC-60309-2-single-16", "Chademo", "DOMESTIC-F", "IEC-62196-T2", "IEC-62196-T1", "IEC-62196-T1-COMBO", "IEC-62196-T2-COMBO", "IEC-62196-T3A", "IEC-62196-T3C", "DOMESTIC-A", "DOMESTIC-B", "DOMESTIC-C", "DOMESTIC-D", "DOMESTIC-E", "DOMESTIC-G", "DOMESTIC-H", "DOMESTIC-I", "DOMESTIC-J", "DOMESTIC-K", "DOMESTIC-L", "TESLA-R", "TESLA-S", "IEC-60309-2-three-16", "IEC-60309-2-three-32", "IEC-60309-2-three-64"];
		window.localStorage['searchconnectorArray'] = JSON.stringify(tempArray);
		$scope.change("searchavailable", false);
		$scope.change("searchpaywithapp", false);
		$scope.change("searchchargeEnergy", 0);
		$scope.readFilterSettings();
	}
	
	// Init function 
	$scope.init = function() {
		gps.determineLocation(false, false);

		if ($ionicSideMenuDelegate.isOpenRight() == true) {
			$ionicSideMenuDelegate.toggleRight();
		}
		
		if (window.localStorage['vat'] == 'true') {
			$scope.setting.vat = true;
		}
		else {
			$scope.setting.vat = false;
		}
		
		$scope.user.firstNameInfo = window.localStorage['firstName'];
		$scope.user.lastNameInfo = window.localStorage['lastName'];
		$scope.user.emailInfo = window.localStorage['email'];
		$scope.user.accountInfo = window.localStorage['customerType'];
		
		$scope.setting.results = window.localStorage['results'];
		$scope.setting.searchrange = window.localStorage['searchrange'];
		$scope.setting.language = window.localStorage['setLanguage']; 
				
		general.keepScreenOn(false);
		$scope.readFilterSettings();
	}
}]);