angular.module('lms.controllers').controller('TransactionCtrl', ['$scope', '$http', '$stateParams', 'convert', '$timeout', 'general', 'gps', 'appData', 'intervalDataService', 'intervalTransactionData', 'intervalCallback',
																function($scope, $http, $stateParams, convert, $timeout, general, gps, appData, intervalDataService, intervalTransactionData, intervalCallback) {
	// Declaration scope variables
	$scope.loading = 'loading';
	$scope.transactionStatus;
	$scope.transactionStatusText;
	$scope.chargePointAddress;
	$scope.chargePointCity;
	$scope.chargePointZipCode;
	$scope.chargePointVisibleId;
	$scope.chargePointId;
	$scope.startDate;
	$scope.endDate;
	$scope.chargeTime;
	$scope.chargeTimeNow;
	$scope.energyDelivered;
	$scope.totalAmount;
	$scope.stop = false;
	$scope.transactionStopBusy = false;
	
	// Events
	$scope.$on('$destroy',function(){
        intervalDataService.stop("transactionInterval");   
	});
	
	$scope.$on('$ionicView.enter', function(){
	  intervalDataService.start("transactionInterval", 5000);
	  //intervalTransactionData.transactionId = $stateParams.transactionId;
	});
	
	$scope.$on('$ionicView.leave', function(){
	  intervalDataService.stop("transactionInterval");  
	});
	
	// scope functions
	$scope.doRefresh = function() {
		intervalCallback.transaction("transactionInterval");
	};
	  
	$scope.stopTransaction = function () {
		  $scope.transactionStopBusy = true;
		  $http({
			url: general.server(),
			method: "POST",
			data: {action:'stopTransaction',parameters:{token:window.localStorage['token'], version: appData.appVersion, transactionId: $stateParams.transactionId, deviceId: appData.uuid}},
			headers: {'Content-Type': 'application/json'}
		  }).success(function (data, status, headers, config) {
				if (status == 200 || status == 304) {
					if (data['status'] == "valid") {
						
					}
					else if (data['status'] == "versionTooLow") {
						general.versionToLow(); 
					}
					else {
						
						//nog invullen -> invalid
					}
				}
				 $scope.$broadcast('scroll.refreshComplete');
			}).error(function (data, status, headers, config) {
				//alert(status);
				//alert("fout");
				$scope.$broadcast('scroll.refreshComplete');
				$scope.transactionStopBusy = false;
			});
	  };
	  
	 //event from intervalDataService
	intervalDataService.newIntervalDataCallback('transactionInterval', $scope, function() { // new
		$scope.$broadcast('scroll.refreshComplete');
		if (intervalTransactionData.transactionStatus == 'committed' || intervalTransactionData.transactionStatus == 'finished' || intervalTransactionData.transactionStatus == 'paymentFailed' || intervalTransactionData.transactionStatus == 'notStarted') {
			intervalDataService.stop("transactionInterval"); // stop requesting information
		}
		else if (intervalTransactionData.transactionStatus == 'charging' || intervalTransactionData.transactionStatus == 'chargingVehicleFull ') {
			intervalDataService.start("transactionInterval", 15000);
		}
		else {
			intervalDataService.start("transactionInterval", 5000);
		}
		
		$scope.loading = intervalTransactionData.loading;
		$scope.transactionStatus = intervalTransactionData.transactionStatus;
		$scope.transactionStatusText = convert.statusText(intervalTransactionData.transactionStatus);
		$scope.chargePointAddress = intervalTransactionData.chargePointAddress;
		$scope.chargePointCity = intervalTransactionData.chargePointCity;
		$scope.chargePointZipCode = intervalTransactionData.chargePointZipCode;
		$scope.chargePointVisibleId = intervalTransactionData.chargePointVisibleId;
		$scope.chargePointId = intervalTransactionData.chargePointId;
		$scope.startDate = convert.hours(intervalTransactionData.startDate) + " (" + convert.date(intervalTransactionData.startDate) + ")";
		console.log(intervalTransactionData.endDate);
		if ((intervalTransactionData.transactionStatus == 'paymentFailed' || intervalTransactionData.transactionStatus == 'notStarted') && intervalTransactionData.endDate == null) {
			$scope.chargeTimeNow = "0s";
		}
		else {
			$scope.chargeTimeNow = convert.time(Math.round(Date.now()/1000) - intervalTransactionData.startDate, false);
		}
		$scope.endDate = convert.hours(intervalTransactionData.endDate) + " (" + convert.date(intervalTransactionData.endDate) + ")";
		$scope.chargeTime = convert.time(intervalTransactionData.endDate - intervalTransactionData.startDate, false);
		$scope.energyDelivered = convert.energy(intervalTransactionData.energyDelivered) + 'h';
		$scope.totalAmount = convert.valuta(intervalTransactionData.totalAmount, intervalTransactionData.vat);
    });
	
	// Init function
	$scope.init = function() {
		console.log($stateParams.transactionId);
		intervalTransactionData.transactionId = $stateParams.transactionId;
		gps.determineLocation(false, false);
		intervalDataService.start("transactionInterval", 5000);
	}	
}]);