angular.module('lms.controllers').controller('TransactionsCtrl', ['$scope', '$http', 'convert', '$stateParams', '$filter', 'general', 'gps', 'appData',
																	function($scope, $http, convert, $stateParams, $filter, general, gps, appData) {
 
  // Declaration scope variables
  $scope.startResult = $stateParams.startResult;
  $scope.endResult = $stateParams.endResult;
  $scope.transactions = [];
  $scope.loading = 'loading';
  $scope.moreResults = false;
  $scope.results = window.localStorage['results'];
  
  // Scope functions
  $scope.loadContent = function(doRefresh) {
	  
	  if (doRefresh != true) {
		$scope.loading = 'loading';
	  }
	  $http({
		url: general.server(),
		method: "POST",
		data: {action:'getTransactions',parameters:{token:window.localStorage['token'], version: appData.appVersion, deviceId: appData.uuid, mode: "customerTransactionsAll", startResult: $scope.startResult, endResult: $scope.endResult}},
		headers: {'Content-Type': 'application/json'}
	  }).success(function (data, status, headers, config) {
			if (status == 200 || status == 304) {
				$scope.loading = 'loaded';
				if (data['status'] == "valid") {
					$scope.transactions = [];
					$scope.moreResults = data['moreResults'];
					if (data['transactions'].length != 0) {
						angular.forEach(data['transactions'],function(transaction, index){
								 $scope.transactions.push({
									transactionStatus: transaction.transactionStatus,
									transactionId: transaction.transactionId,
									chargeDate: convert.date(transaction.startDate),
									chargePointAddress: transaction.chargePointAddress,
									chargeTime: convert.time(transaction.endDate - transaction.startDate, true),
									chargeTariff: convert.valuta(transaction.totalAmount, transaction.vat)
								});
						});
					}
					else {
						$scope.transactions = null;
					}
				}
				else if (data['status'] == "versionTooLow") {
					general.versionToLow(); 
				}
				else {
					
					//nog invullen -> invalid
				}
			}
			 $scope.$broadcast('scroll.refreshComplete');
		}).error(function (data, status, headers, config) {
			$scope.loading = 'error';
			$scope.$broadcast('scroll.refreshComplete');
		});
	};
	
	$scope.doRefresh = function() {
		this.loadContent(true);
	};
	  
	// Init function 
	$scope.init = function() {
		gps.determineLocation(false, false);
		$scope.loadContent(false);
	}
}]);