angular.module('lms.controllers').controller('TransactionsettingsCtrl', ['$scope', '$http', '$stateParams', 'convert', '$state', 'general', 'gps', 'appData', 
																		function($scope, $http, $stateParams, convert, $state, general, gps, appData) {
	// Declaration scope variables
	$scope.chargepoints = [];
	$scope.chargepointIds = [$stateParams.chargePointId];
	$scope.channelsAvailable = $stateParams.channelsAvailable.split(",");
	$scope.startTariff = $stateParams.startTariff;
	$scope.kWhTariff = $stateParams.kWhTariff; 
	$scope.minuteTariff = $stateParams.minuteTariff;
	$scope.searchchargeEnergy = 1;
	$scope.searchconnector = null;
	$scope.chargeCheckbox = true;
	$scope.loading = false;
	$scope.startTransactionBusy = false;
	
	// Scope functions
	$scope.startTransactionProcess = function(connectorSelected, paymentMethod, energySelected, chargeCheckbox) {
		var tempenergy = energySelected * 1000; 
		$scope.startTransactionBusy = true;
		if (chargeCheckbox == true) {
			tempenergy = null; 
		}
		$http({
		url: general.server(),
		method: "POST",
		data: {action:'startTransaction',parameters:{token:window.localStorage['token'], version: appData.appVersion, deviceId: appData.uuid, chargePointId: $stateParams.chargePointId, channel: connectorSelected, paymentMethod: paymentMethod, energy: tempenergy}},
		headers: {'Content-Type': 'application/json'}
	  }).success(function (data, status, headers, config) {
			if (status == 200 || status == 304) {
				if (data['status'] == "valid") {
					$scope.loading = false;
					window.localStorage['transactionsInProgress'] = true;
					if (data['paypalToken'] != null) {
						window.open('https://www.paypal.com/cgi-bin/webscr?cmd=_express-checkout&useraction=commit&token='+data['paypalToken']+'', '_system');
					}
					else {
						if (data['transactionId'] != null) {
							$state.go('app.transaction', {"transactionId": data['transactionId']});
							window.localStorage['transactionId'] = data['transactionId'];
						}
						else {
							general.alert("Oeps...","transactionId == null Debuginformation");
						}
					}
				}
				else if (data['status'] == "versionTooLow") {
					general.versionToLow(); 
				}
				else {
					general.softlogout();
				}
			}
			 $scope.startTransactionBusy = false;
			 $scope.$broadcast('scroll.refreshComplete');
		}).error(function (data, status, headers, config) {
			$scope.startTransactionBusy = false;
			$scope.$broadcast('scroll.refreshComplete');
		});
	}
	
	// Init function
	$scope.init = function() {
		gps.determineLocation(false, false);
		if ($scope.channelsAvailable.length > 0) {
			$scope.searchconnector = $scope.channelsAvailable[0];
		}
	}
}]);